/* Generated by powerful Codeforces Tool
 * Author: $%U%$
 * Time: $%Y%$-$%M%$-$%D%$ $%h%$:$%m%$
 **/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b){ return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b){ return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const ll MOD = 998'244'353;

const ll MAXN = 2e5 + 5;
const ll INF = 1LL << 60;

ll N;

void solve(){
    // Code goes here ...
    cin >> N;

    vector<set<int>> edges(N);
    R(i, N - 1){
        int u, v;
        cin >> u >> v;
        u--, v--;
        edges[u].insert(v);
        edges[v].insert(u);
    }

    if(N <= 2){
        cout << 0 << endl;
        return;
    }

    int components = 1;
    vector<int> firstnodes;

    int maxsize = -1, cursize;
    R(i, N){
        cursize = ssize(edges[i]);
        if(cursize == maxsize){
            firstnodes.push_back(i);
        }
        if(cursize > maxsize){
            maxsize = cursize;
            firstnodes = {i};
        }
    }
    components += maxsize - 1;

    int maxmaxsize = -1;
    int maxits = ssize(firstnodes);
    ckmin(maxits, 3);
    for(int i = 0; i < maxits; i++){
        int curnode = firstnodes[i];

        // int maxnode = -1;
        int maxsize = -1;
        R(i, N){
            if(i == curnode) continue;

            int cursize = ssize(edges[i]);
            if(edges[i].contains(curnode)) cursize--;

            if(cursize > maxsize){
                // maxnode = i;
                maxsize = cursize;
            }
        }
        ckmax(maxmaxsize, maxsize);

    }
    components += maxmaxsize - 1;



    cout << components << endl;
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    cin >> T;
    while(T--)
        solve();

    /* string rest; */
    /* while(cin.peek() != char_traits<char>::eof()){ */
    /*     solve(); */
    /*     getline(cin, rest); */
    /* } */

    return 0;
}
        
